import { HttpModule } from "@nestjs/axios";
import { Module } from "@nestjs/common";
import { PapersController } from "src/application";
import { SearchService } from "../../core/services/common/search.service";

/**
 * Search module
 */
@Module({
    imports: [
        HttpModule,
    ],
    exports: [SearchService],
    providers: [SearchService],
    controllers: [PapersController],
})
export class SearchModule {}